Attribute VB_Name = "MOD_tv"
Option Explicit

'==================================================================================
'   Renvoie le neu juste en bas d'un neu
'==================================================================================
Public Function NextNode(Neu As Node, Optional Prof As Long) As Node
    On Error GoTo gestion_erreur
    If Neu.Children <> 0 Then
        Set NextNode = Neu.Child
        Prof = Prof + 1
    Else
        If Neu = Neu.LastSibling Then
            While (Neu = Neu.LastSibling)    'And (Prof <> 0)
                Set Neu = Neu.Parent
                Prof = Prof - 1
            Wend
        End If
        Set NextNode = Neu.Next
    End If
    Exit Function
gestion_erreur:

End Function



'==================================================================================
'   ENREGISTRE LE CONTENU D UNE TREE VIEW DANS UN FICHIER TEXTE
'   RETOURNE 0 SI TOUT C EST BIEN PASSER LE NUMERO DE L ERR SINON
'==================================================================================
Public Function EcritContenuTREEVIEWdansFichier(ByVal TreeView As Object, ByRef NomFichier As String) As Long
    Dim TextStream    'as textstream
    Dim i As Long
    Dim j As Long
    Dim tempo As String
    Dim Result As Long
    Dim Neu As Node


    'On Error GoTo gestion_erreur

    Result = CreerFichierTexte(NomFichier, TextStream)
    If Result = 0 Then




        'For i = 1 To TreeView.Nodes.Count
        Set Neu = TreeView.Nodes(1)
        While Not Neu Is Nothing
            On Error Resume Next
            tempo = Neu.Text + Chr(9) + _
                    CStr(Neu.Parent.Key) + Chr(9) + _
                    Neu.Key + Chr(9) + _
                    CStr(Neu.Image) + Chr(9) + _
                    CStr(Neu.Selectedimage)
            If Err.Number <> 0 Then
                tempo = Neu.Text + Chr(9) + _
                        "" + Chr(9) + _
                        Neu.Key + Chr(9) + _
                        CStr(Neu.Image) + Chr(9) + _
                        CStr(Neu.Selectedimage)
                Err.Clear
            End If

            tempo = Replace(tempo, "\", "/")
            TextStream.WriteLine tempo

            'Next i
            Set Neu = NextNode(Neu)
        Wend

        EcritContenuTREEVIEWdansFichier = FermeFichier(TextStream)

    Else
        EcritContenuTREEVIEWdansFichier = Result
    End If

    Exit Function
    'gestion_erreur:
    '   EcritContenuTREEVIEWdansFichier = Err.Number
End Function

'==================================================================================
'   REMPLIS UNE LISTVIEW AVEC LE CONTENU D UN FICHIER TEXTE SEPARATEUR TABULATION
'   RETOURNE 0 SI TOUT C EST BIEN PASSER LE NUMERO DE L ERR SINON
'==================================================================================
Public Function LisContenuTREEVIEWdepuisFichier(ByVal TreeView As Object, ByRef NomFichier As String)
    Dim TextStream    'as textstream
    Dim LigneTexte As String
    Dim Texte As String
    Dim Parent As String
    Dim Result As Long
    Dim Key As String
    Dim Image As String
    Dim Selectedimage As String
    Dim aNeu As Node


    On Error GoTo gestion_erreur

    TreeView.Nodes.Clear
    Result = OuvreFichierTexte(NomFichier, TextStream, True)
    If Result = 0 Then


        Do
            LigneTexte = TextStream.ReadLine

            Texte = Mid(LigneTexte, 1, InStr(1, LigneTexte, Chr(9), vbTextCompare) - 1)
            LigneTexte = Replace(LigneTexte, Texte + Chr(9), "", , 1)

            If Mid(LigneTexte, 1, 1) = Chr(9) Then
                Parent = 0
                LigneTexte = Mid(LigneTexte, 2)
            Else
                Parent = (Mid(LigneTexte, 1, InStr(1, LigneTexte, Chr(9), vbTextCompare) - 1))
                LigneTexte = Replace(LigneTexte, CStr(Parent) + Chr(9), "", , 1)
            End If

            Key = Mid(LigneTexte, 1, InStr(1, LigneTexte, Chr(9), vbTextCompare) - 1)
            LigneTexte = Replace(LigneTexte, Key + Chr(9), "", , 1)

            Image = Mid(LigneTexte, 1, InStr(1, LigneTexte, Chr(9), vbTextCompare) - 1)
            LigneTexte = Replace(LigneTexte, Image + Chr(9), "", , 1)

            Selectedimage = LigneTexte

            If Selectedimage = "" Then Selectedimage = Image

            If Parent <> "0" Then
               TreeView.Nodes.Add Parent, 4, Key, Texte, CLng(Image), CLng(Selectedimage)
            Else
                TreeView.Nodes.Add , , Key, Texte, CLng(Image), CLng(Selectedimage)
            End If

        Loop Until TextStream.AtEndOfStream

        LisContenuTREEVIEWdepuisFichier = FermeFichier(TextStream)

    Else
        LisContenuTREEVIEWdepuisFichier = Result
    End If
    Exit Function
gestion_erreur:
    LisContenuTREEVIEWdepuisFichier = Err.Number
End Function



